Index: IMGUI/imgui_demo.cpp
===================================================================
--- IMGUI/imgui_demo.cpp	(revision c58ebc3899e898504313cf42b9c1c05170b13f8f)
+++ IMGUI/imgui_demo.cpp	(revision 670c09af1971c9568423ac0b125725b93b7fb2f7)
@@ -1511,81 +2995,105 @@
             ImGui::Text("Tooltip here");
             if (ImGui::IsItemHovered())
-               ImGui::SetTooltip("I am a tooltip over a popup");
+                ImGui::SetTooltip("I am a tooltip over a popup");
 
             if (ImGui::Button("Stacked Popup"))
-               ImGui::OpenPopup("another popup");
+                ImGui::OpenPopup("another popup");
             if (ImGui::BeginPopup("another popup"))
             {
-               for (int i = 0; i < IM_ARRAYSIZE(names); i++)
-                  ImGui::MenuItem(names[i], "", &toggles[i]);
-               if (ImGui::BeginMenu("Sub-menu"))
-               {
-                  ImGui::MenuItem("Click me");
-                  ImGui::EndMenu();
-               }
-               ImGui::EndPopup();
+                for (int i = 0; i < IM_ARRAYSIZE(names); i++)
+                    ImGui::MenuItem(names[i], "", &toggles[i]);
+                if (ImGui::BeginMenu("Sub-menu"))
+                {
+                    ImGui::MenuItem("Click me");
+                    if (ImGui::Button("Stacked Popup"))
+                        ImGui::OpenPopup("another popup");
+                    if (ImGui::BeginPopup("another popup"))
+                    {
+                        ImGui::Text("I am the last one here.");
+                        ImGui::EndPopup();
+                    }
+                    ImGui::EndMenu();
+                }
+                ImGui::EndPopup();
             }
             ImGui::EndPopup();
-         }
-
-         if (ImGui::Button("Popup Menu.."))
-            ImGui::OpenPopup("FilePopup");
-         if (ImGui::BeginPopup("FilePopup"))
-         {
+        }
+
+        // Call the more complete ShowExampleMenuFile which we use in various places of this demo
+        if (ImGui::Button("File Menu.."))
+            ImGui::OpenPopup("my_file_popup");
+        if (ImGui::BeginPopup("my_file_popup"))
+        {
             ShowExampleMenuFile();
             ImGui::EndPopup();
-         }
-
-         ImGui::TreePop();
-      }
-
-      if (ImGui::TreeNode("Context menus"))
-      {
-         // BeginPopupContextItem() is a helper to provide common/simple popup behavior of essentially doing:
-         //    if (IsItemHovered() && IsMouseClicked(0))
-         //       OpenPopup(id);
-         //    return BeginPopup(id);
-         // For more advanced uses you may want to replicate and cuztomize this code. This the comments inside BeginPopupContextItem() implementation.
-         static float value = 0.5f;
-         ImGui::Text("Value = %.3f (<-- right-click here)", value);
-         if (ImGui::BeginPopupContextItem("item context menu"))
-         {
+        }
+
+        ImGui::TreePop();
+    }
+
+    if (ImGui::TreeNode("Context menus"))
+    {
+        // BeginPopupContextItem() is a helper to provide common/simple popup behavior of essentially doing:
+        //    if (IsItemHovered() && IsMouseReleased(ImGuiMouseButton_Right))
+        //       OpenPopup(id);
+        //    return BeginPopup(id);
+        // For more advanced uses you may want to replicate and customize this code.
+        // See details in BeginPopupContextItem().
+        static float value = 0.5f;
+        ImGui::Text("Value = %.3f (<-- right-click here)", value);
+        if (ImGui::BeginPopupContextItem("item context menu"))
+        {
             if (ImGui::Selectable("Set to zero")) value = 0.0f;
             if (ImGui::Selectable("Set to PI")) value = 3.1415f;
-            ImGui::PushItemWidth(-1);
+            ImGui::SetNextItemWidth(-1);
             ImGui::DragFloat("##Value", &value, 0.1f, 0.0f, 0.0f);
-            ImGui::PopItemWidth();
             ImGui::EndPopup();
-         }
-
-         static char name[32] = "Label1";
-         char buf[64]; sprintf(buf, "Button: %s###Button", name); // ### operator override ID ignoring the preceding label
-         ImGui::Button(buf);
-         if (ImGui::BeginPopupContextItem()) // When used after an item that has an ID (here the Button), we can skip providing an ID to BeginPopupContextItem().
-         {
+        }
+
+        // We can also use OpenPopupOnItemClick() which is the same as BeginPopupContextItem() but without the
+        // Begin() call. So here we will make it that clicking on the text field with the right mouse button (1)
+        // will toggle the visibility of the popup above.
+        ImGui::Text("(You can also right-click me to open the same popup as above.)");
+        ImGui::OpenPopupOnItemClick("item context menu", 1);
+
+        // When used after an item that has an ID (e.g.Button), we can skip providing an ID to BeginPopupContextItem().
+        // BeginPopupContextItem() will use the last item ID as the popup ID.
+        // In addition here, we want to include your editable label inside the button label.
+        // We use the ### operator to override the ID (read FAQ about ID for details)
+        static char name[32] = "Label1";
+        char buf[64];
+        sprintf(buf, "Button: %s###Button", name); // ### operator override ID ignoring the preceding label
+        ImGui::Button(buf);
+        if (ImGui::BeginPopupContextItem())
+        {
             ImGui::Text("Edit name:");
             ImGui::InputText("##edit", name, IM_ARRAYSIZE(name));
             if (ImGui::Button("Close"))
-               ImGui::CloseCurrentPopup();
+                ImGui::CloseCurrentPopup();
             ImGui::EndPopup();
-         }
-         ImGui::SameLine(); ImGui::Text("(<-- right-click here)");
-
-         ImGui::TreePop();
-      }
-
-      if (ImGui::TreeNode("Modals"))
-      {
-         ImGui::TextWrapped("Modal windows are like popups but the user cannot close them by clicking outside the window.");
-
-         if (ImGui::Button("Delete.."))
+        }
+        ImGui::SameLine(); ImGui::Text("(<-- right-click here)");
+
+        ImGui::TreePop();
+    }
+
+    if (ImGui::TreeNode("Modals"))
+    {
+        ImGui::TextWrapped("Modal windows are like popups but the user cannot close them by clicking outside.");
+
+        if (ImGui::Button("Delete.."))
             ImGui::OpenPopup("Delete?");
-         if (ImGui::BeginPopupModal("Delete?", NULL, ImGuiWindowFlags_AlwaysAutoResize))
-         {
+
+        // Always center this window when appearing
+        ImVec2 center(ImGui::GetIO().DisplaySize.x * 0.5f, ImGui::GetIO().DisplaySize.y * 0.5f);
+        ImGui::SetNextWindowPos(center, ImGuiCond_Appearing, ImVec2(0.5f, 0.5f));
+
+        if (ImGui::BeginPopupModal("Delete?", NULL, ImGuiWindowFlags_AlwaysAutoResize))
+        {
             ImGui::Text("All those beautiful files will be deleted.\nThis operation cannot be undone!\n\n");
             ImGui::Separator();
 
-            //static int dummy_i = 0;
-            //ImGui::Combo("Combo", &dummy_i, "Delete\0Delete harder\0");
+            //static int unused_i = 0;
+            //ImGui::Combo("Combo", &unused_i, "Delete\0Delete harder\0");
 
             static bool dont_ask_me_next_time = false;
@@ -1599,92 +3107,121 @@
             if (ImGui::Button("Cancel", ImVec2(120, 0))) { ImGui::CloseCurrentPopup(); }
             ImGui::EndPopup();
-         }
-
-         if (ImGui::Button("Stacked modals.."))
+        }
+
+        if (ImGui::Button("Stacked modals.."))
             ImGui::OpenPopup("Stacked 1");
-         if (ImGui::BeginPopupModal("Stacked 1"))
-         {
-            ImGui::Text("Hello from Stacked The First\nUsing style.Colors[ImGuiCol_ModalWindowDarkening] for darkening.");
+        if (ImGui::BeginPopupModal("Stacked 1", NULL, ImGuiWindowFlags_MenuBar))
+        {
+            if (ImGui::BeginMenuBar())
+            {
+                if (ImGui::BeginMenu("File"))
+                {
+                    if (ImGui::MenuItem("Some menu item")) {}
+                    ImGui::EndMenu();
+                }
+                ImGui::EndMenuBar();
+            }
+            ImGui::Text("Hello from Stacked The First\nUsing style.Colors[ImGuiCol_ModalWindowDimBg] behind it.");
+
+            // Testing behavior of widgets stacking their own regular popups over the modal.
             static int item = 1;
+            static float color[4] = { 0.4f, 0.7f, 0.0f, 0.5f };
             ImGui::Combo("Combo", &item, "aaaa\0bbbb\0cccc\0dddd\0eeee\0\0");
-            static float color[4] = { 0.4f,0.7f,0.0f,0.5f };
-            ImGui::ColorEdit4("color", color);  // This is to test behavior of stacked regular popups over a modal
+            ImGui::ColorEdit4("color", color);
 
             if (ImGui::Button("Add another modal.."))
-               ImGui::OpenPopup("Stacked 2");
-            if (ImGui::BeginPopupModal("Stacked 2"))
-            {
-               ImGui::Text("Hello from Stacked The Second!");
-               if (ImGui::Button("Close"))
-                  ImGui::CloseCurrentPopup();
-               ImGui::EndPopup();
+                ImGui::OpenPopup("Stacked 2");
+
+            // Also demonstrate passing a bool* to BeginPopupModal(), this will create a regular close button which
+            // will close the popup. Note that the visibility state of popups is owned by imgui, so the input value
+            // of the bool actually doesn't matter here.
+            bool unused_open = true;
+            if (ImGui::BeginPopupModal("Stacked 2", &unused_open))
+            {
+                ImGui::Text("Hello from Stacked The Second!");
+                if (ImGui::Button("Close"))
+                    ImGui::CloseCurrentPopup();
+                ImGui::EndPopup();
             }
 
             if (ImGui::Button("Close"))
-               ImGui::CloseCurrentPopup();
+                ImGui::CloseCurrentPopup();
             ImGui::EndPopup();
-         }
-
-         ImGui::TreePop();
-      }
-
-      if (ImGui::TreeNode("Menus inside a regular window"))
-      {
-         ImGui::TextWrapped("Below we are testing adding menu items to a regular window. It's rather unusual but should work!");
-         ImGui::Separator();
-         // NB: As a quirk in this very specific example, we want to differentiate the parent of this menu from the parent of the various popup menus above.
-         // To do so we are encloding the items in a PushID()/PopID() block to make them two different menusets. If we don't, opening any popup above and hovering our menu here
-         // would open it. This is because once a menu is active, we allow to switch to a sibling menu by just hovering on it, which is the desired behavior for regular menus.
-         ImGui::PushID("foo");
-         ImGui::MenuItem("Menu item", "CTRL+M");
-         if (ImGui::BeginMenu("Menu inside a regular window"))
-         {
+        }
+
+        ImGui::TreePop();
+    }
+
+    if (ImGui::TreeNode("Menus inside a regular window"))
+    {
+        ImGui::TextWrapped("Below we are testing adding menu items to a regular window. It's rather unusual but should work!");
+        ImGui::Separator();
+
+        // Note: As a quirk in this very specific example, we want to differentiate the parent of this menu from the
+        // parent of the various popup menus above. To do so we are encloding the items in a PushID()/PopID() block
+        // to make them two different menusets. If we don't, opening any popup above and hovering our menu here would
+        // open it. This is because once a menu is active, we allow to switch to a sibling menu by just hovering on it,
+        // which is the desired behavior for regular menus.
+        ImGui::PushID("foo");
+        ImGui::MenuItem("Menu item", "CTRL+M");
+        if (ImGui::BeginMenu("Menu inside a regular window"))
+        {
             ShowExampleMenuFile();
             ImGui::EndMenu();
-         }
-         ImGui::PopID();
-         ImGui::Separator();
-         ImGui::TreePop();
-      }
-   }
-
-   if (ImGui::CollapsingHeader("Columns"))
-   {
-      ImGui::PushID("Columns");
-
-      // Basic columns
-      if (ImGui::TreeNode("Basic"))
-      {
-         ImGui::Text("Without border:");
-         ImGui::Columns(3, "mycolumns3", false);  // 3-ways, no border
-         ImGui::Separator();
-         for (int n = 0; n < 14; n++)
-         {
+        }
+        ImGui::PopID();
+        ImGui::Separator();
+        ImGui::TreePop();
+    }
+}
+
+static void ShowDemoWindowColumns()
+{
+    if (!ImGui::CollapsingHeader("Columns"))
+        return;
+
+    ImGui::PushID("Columns");
+
+    static bool disable_indent = false;
+    ImGui::Checkbox("Disable tree indentation", &disable_indent);
+    ImGui::SameLine();
+    HelpMarker("Disable the indenting of tree nodes so demo columns can use the full window width.");
+    if (disable_indent)
+        ImGui::PushStyleVar(ImGuiStyleVar_IndentSpacing, 0.0f);
+
+    // Basic columns
+    if (ImGui::TreeNode("Basic"))
+    {
+        ImGui::Text("Without border:");
+        ImGui::Columns(3, "mycolumns3", false);  // 3-ways, no border
+        ImGui::Separator();
+        for (int n = 0; n < 14; n++)
+        {
             char label[32];
             sprintf(label, "Item %d", n);
             if (ImGui::Selectable(label)) {}
-            //if (ImGui::Button(label, ImVec2(-1,0))) {}
+            //if (ImGui::Button(label, ImVec2(-FLT_MIN,0.0f))) {}
             ImGui::NextColumn();
-         }
-         ImGui::Columns(1);
-         ImGui::Separator();
-
-         ImGui::Text("With border:");
-         ImGui::Columns(4, "mycolumns"); // 4-ways, with border
-         ImGui::Separator();
-         ImGui::Text("ID"); ImGui::NextColumn();
-         ImGui::Text("Name"); ImGui::NextColumn();
-         ImGui::Text("Path"); ImGui::NextColumn();
-         ImGui::Text("Hovered"); ImGui::NextColumn();
-         ImGui::Separator();
-         const char* names[3] = { "One", "Two", "Three" };
-         const char* paths[3] = { "/path/one", "/path/two", "/path/three" };
-         static int selected = -1;
-         for (int i = 0; i < 3; i++)
-         {
+        }
+        ImGui::Columns(1);
+        ImGui::Separator();
+
+        ImGui::Text("With border:");
+        ImGui::Columns(4, "mycolumns"); // 4-ways, with border
+        ImGui::Separator();
+        ImGui::Text("ID"); ImGui::NextColumn();
+        ImGui::Text("Name"); ImGui::NextColumn();
+        ImGui::Text("Path"); ImGui::NextColumn();
+        ImGui::Text("Hovered"); ImGui::NextColumn();
+        ImGui::Separator();
+        const char* names[3] = { "One", "Two", "Three" };
+        const char* paths[3] = { "/path/one", "/path/two", "/path/three" };
+        static int selected = -1;
+        for (int i = 0; i < 3; i++)
+        {
             char label[32];
             sprintf(label, "%04d", i);
             if (ImGui::Selectable(label, selected == i, ImGuiSelectableFlags_SpanAllColumns))
-               selected = i;
+                selected = i;
             bool hovered = ImGui::IsItemHovered();
             ImGui::NextColumn();
